#include "windows.inc"
#include "resource.inc"
#include "commctrl.inc"
#include "shlobj.inc"
#include "shlwapi.inc"
#include "stdio.inc"

declare extern matchwild(byte *name, byte *pat),int;

const MaxItemsToRemember = 20;

class CDlg
{
	declare OnCreate();
	declare OnClose();
	declare OnCommand(WPARAM wParam,HWND hwndFrom);
	declare OnContextMenu(HWND hwndFrom,int x,int y);
	declare OnSize(HWND hwndFrom,int x,int y);
	declare OnMinMaxInfo(MINMAXINFO *mmi);
	// settings
	declare LoadSettings();
	declare SaveSettings();
	declare SaveListToStream(int id, string szValue);
	declare LoadListFromStream(int id, string szValue);
	// util
	declare ChangeFolder();
	declare FolderExists(string szPath),BOOL;
	declare DisplayExports();
	declare MessageBox(string *txt);
	// scan
	declare ScanThread();
	declare ScanFolders(string szFolder);
	declare ScanExportDir(string szPath,CStringList *names),BOOL;
	declare AppendItemToList(int id);
	// shell menu
	declare ProcessShellMenuMessages(UINT uMsg, WPARAM wParam,LPARAM lParam),BOOL;
	declare ShowShellMenu(string szImagePath,int x,int y);
	declare OnShellMenuMessage(UINT uMsg, WPARAM wParam,LPARAM lParam),BOOL;
	declare OnMenuSelect(WPARAM wParam,LPARAM lParam),BOOL;
	// regex
	declare TokenizeFilter();

	HWND    m_hwnd;
	int     m_width;
	HMENU   m_HelpMenu1; // regex help 1
	HMENU   m_HelpMenu2; // regex help 2
	HANDLE  m_hThread;   // nonzero while searching
	int     m_FoundCount;
	BOOL    m_MatchCase; // api compare flag
	BOOL    m_WholeWord; // api compare flag
	BOOL    m_SearchTree;// search in subfolders

	BOOL    m_ShellMenuActive; // m_pcm should be valid; do not change status text while m_ShellMenuActive is true
	IContextMenu2 *m_pcm;

	dstring m_szApi[MAX_PATH];    // in lower case if m_MatchCase is false
	dstring m_szFilter[MAX_PATH]; // tokens terminated with NULL; every token is pointed by m_pFilters[]
	string *m_pFilters[64]; // max 64 patterns in m_szFilter (*.dll;*.wcx;*.txt); or NULL terminated
}


/*         Shell context menu support         *\

http://netez.com/2xExplorer/shellFAQ/bas_context.html


*/



